#!/usr/bin/env python

import hoca
from interface import CA_wrapper, CA_set_wrapper, Display, start
from random import randint


def my_example(w=150, r=None, c=None):
    if r == None:
        r = (randint(0,255), randint(0,255))
    if c == None:
        c = (randint(0,3), randint(0,3))
    pats = CA_set_wrapper("ca%d-cb%d-fa%d-fb%d-long" % (c+r))
    two_nbh = ( hoca.radiusNbh(1), )
    two_rule = []
    for rule in r:
        f = hoca.WolframRule(rule)
        two_rule.append(f)

    tmap = hoca.TotExTMap(*c)
    l = hoca.Lattice(two_nbh, two_rule, tmap, 1, w)
    l.state[0][:] = 1
    l.state[0][w/2] = 0
    state = hoca.LatticeStack(l)
    pats.append(CA_wrapper(state, "HOCA", "ca:%d cb:%d fa:%d fb:%d" % (c+r)))

    pats[-1].display.append(Display("state", 0, 0, "255*(1-data)"))
    pats[-1].display.append(Display("rule", 0, None, "255*(1-data)"))

    return pats

def my_list():
    for (r,c) in (((114,148),(3,3)),):
        yield my_example(105, r, c)

args = {"iterator": my_list(),
        "height": 400}

start(**args)
