#!/usr/bin/env python

import hoca
from interface import CA_wrapper, CA_set_wrapper, Display, start
from random import randint


def my_example(w=150, ini="1", r=(241,94), c=(1,2)):
    pats = CA_set_wrapper("ca%d-cb%d-fa%d-fb%d-%s-w%d" % (c+r+(ini,w)))
    two_nbh = ( hoca.radiusNbh(1), )
    two_rule = []
    for rule in r:
        f = hoca.WolframRule(rule)
        two_rule.append(f)

    tmap = hoca.TotExTMap(*c)
    l = hoca.Lattice(two_nbh, two_rule, tmap, 1, w)
    l.state[0][:] = 1
    start = w/2-len(ini)/2
    l.state[0][start:start+len(ini)] = [int(x) for x in ini]
    state = hoca.LatticeStack(l)
    pats.append(CA_wrapper(state, "HOCA", "..1" + ini + "1.." +
                           " (%d)" % w))

    pats[-1].display.append(Display("state", 0, 0, "255*(1-data)"))
    pats[-1].display.append(Display("rule", 0, None, "255*(1-data)"))

    return pats

def my_list():
    for (ini, w) in (("0101001100", 122), ("00011010", 122),
                ("000100", 122), ("000100", 121),
                ("001011010", 122), ("0010010", 122)):
        yield my_example(w, ini)

args = {"iterator": my_list(),
        "height": 350}

start(**args)
