#!/usr/bin/env python

import hoca
from interface import CA_wrapper, CA_set_wrapper, Display, start


def my_example(w=150):
    r = (255, 28)
    c = (3, 2)
    pats = CA_set_wrapper("ca%d-cb%d-fa%d-fb%d" % (c+r))
    two_nbh = ( hoca.radiusNbh(1), )
    two_rule = []
    for rule in r:
        f = hoca.WolframRule(rule)
        l = hoca.Lattice(two_nbh, (f,), hoca.NullTMap(), 1, w)
        l.random()
        ls = hoca.LatticeStack(l)
        pats.append(CA_wrapper(ls, "CA", "Rule %d" % rule))
        pats[-1].display.append(Display("state", 0, 0, "255*(1-data)"))
        two_rule.append(f)

    tmap = hoca.TotExTMap(*c)
    l = hoca.Lattice(two_nbh, two_rule, tmap, 1, w)
    l.random()
    state = hoca.LatticeStack(l)
    pats.append(CA_wrapper(state, "HOCA", "ca:%d cb:%d fa:%d fb:%d" % (c+r)))

    pats[-1].display.append(Display("state", 0, 0, "255*(1-data)"))
    pats[-1].display.append(Display("rule", 0, None, "255*(1-data)"))

    return pats

def yieldn(n):
    for i in range(n):
        yield my_example()

args = {"iterator": yieldn(1),
        "height": 100}

start(**args)
