#!/usr/bin/env python

import hoca
from interface import CA_wrapper, CA_set_wrapper, Display, start
from random import randint


def my_example(w, r, c):
    pats = CA_set_wrapper("ca%d-cb%d-fa%d-fb%d" % (c+r))
    two_nbh = ( hoca.radiusNbh(1), )
    two_rule = []
    for rule in r:
        f = hoca.WolframRule(rule)
        two_rule.append(f)

    tmap = hoca.TotExTMap(*c)
    l = hoca.Lattice(two_nbh, two_rule, tmap, 1, w)
    l.random()
    state = hoca.LatticeStack(l)
    pats.append(CA_wrapper(state, "HOCA", "ca:%d cb:%d fa:%d fb:%d" % (c+r)))

    pats[-1].display.append(Display("state", 0, 0, "255*(1-data)"))
    pats[-1].display.append(Display("rule", 0, None, "255*(1-data)"))

    return pats

def my_list():
    for (r, c) in (
        ((149,149),(0,0)),
        ((31,31),(2,3)),
        ((86,86),(0,1)),
        ((131,131),(1,3)),
        ((183,183),(1,3)),
        ((11,11),(3,1))):
        yield my_example(150, r, c)

args = {"iterator": my_list(),
        "height": 100}

start(**args)
