#!/usr/bin/env python

import sys
from pdfdraw import Make_PDF
from ca import *
from random import randint


examples = (("I", (8, 32, 40, 160), 10, "\\textwidth"),
            ("II", (4, 36, 108, 164), 20, "\\textwidth"),
            ("III", (30, 45, 150), 40, "0.6\\textwidth")
            )

for (cls, exs, height, width) in examples:
    img = Make_PDF("class_%s.pdf" % cls, pagesize="150x%d" % (height+10), 
                   grid="%dx1" % len(exs), caption="Class %s" % cls,
                   placement="h!", width=width)

    for (i,n) in enumerate(exs):
        img.translate()
        r = CA1D_Rule(n)
        l = CA1D_Lattice(size=50, random=True)
        ca = CA1D(lattice=l, rule=r, iterations=height)
        img.draw_ca(ca, (0,0), (img.div_width, img.div_height), "Rule %d" % n)
        
    img.save()


