#!/usr/bin/env python

import sys
from pdfdraw import Make_PDF
from ca import *
from random import randint


img = Make_PDF("rule-24-shifted.pdf", pagesize="30x30", 
               grid="1x2", caption="Rule 24 and the shifted Rule 24",
               placement="h!", width="0.5\\textwidth")

img.translate()
r = CA1D_Rule(24)
l = CA1D_Lattice(size=30, random=True)
ca = CA1D(lattice=l.copy(), rule=r, iterations=10)
img.draw_ca(ca, (0,0), (img.div_width, img.div_height), "Rule 24")

img.translate()
r = CA1D_Rule(24, shift=1)
ca = CA1D(lattice=l, rule=r, iterations=10)
img.draw_ca(ca, (0,0), (img.div_width, img.div_height), "Rule 24 shifted")
        
img.save()


