#!/usr/bin/env python

import sys
from pdfdraw import Make_PDF
from ca import *
from random import randint


img = Make_PDF("rule30-equivalents.pdf", pagesize="150x28", 
               grid="4x1", caption="Equivalent rules of rule 30.",
               placement="h!", width="\\textwidth")

def invert(l):
    l = l.copy()
    l.L = 1 - l.L
    return l

def mirror(l):
    l = l.copy()
    l.L = l.L.copy()[::-1]
    return l

def mirror_inverse(l):
    return mirror(invert(l))

def id(l):
    return l.copy()

l = CA1D_Lattice(size=50, initial="*1*")
for (i, pair) in enumerate(((30, id), (86, mirror), 
                            (135, invert), (149, mirror_inverse))):
    (rule_no, func) = pair
    img.translate()
    r = CA1D_Rule(rule_no)
    ca = CA1D(lattice=func(l), rule=r, iterations=25)
    img.draw_ca(ca, (0,0), (img.div_width, img.div_height), "Rule %d" % rule_no)
    
img.save()


