#!/usr/bin/env python

import watorhoca as hoca
from wator_interface import CA_wrapper, Display, start

def example():
    (w, h) = (120, 90)
    
    # First level lattice, rules, neighbourhoods
    two_nbh = (hoca.vonNeumann(),)
    two_rule = (hoca.WatorRule(8, 20, 20),)
    l1 = hoca.Lattice(two_nbh, two_rule, hoca.NullTMap(), max_state=2, 
                      dim=(w,h), dtypes=("uint8",)*3 + ("bool",), 
                      inplace=True, on_next="self.state[3][:,:] = False; ")
    
    # Put it all together, and specify which parts to display
    ret = CA_wrapper(hoca.LatticeStack(l1), "CA", write_mode="w")
    
    ret.display.append(Display("state", 0, 0, "127*(2-data)"))
    return [ret]


def yieldn(n):
    for i in range(n):
        yield example()

args = {"iterator": yieldn(1),
        "save": [1, 50, 80, 110, 150, 200, 260, 330, 410, 500],
        "end_t": 2000}

start(**args)
